# TIDREF -- Set up local calibration lamp reference file for one TRES spectrum
# By Doug Mink, SAO Telescope Data Center
# January 28, 2008

procedure tidref (spectrum)

file	spectrum=""	{prompt="Spectrum for which to find reference"}

file	idroot="comp"	{prompt="Root filename for dispersion reference spectrum"}
file	iddir="tresdata$"	{prompt="Directory for reference spectra"}
file	imref=""	{prompt="Dispersion reference file (returned)"}
bool	verbose=yes	{prompt="Log progress (y or n)"}
bool	debug=yes	{prompt="Print debugging information (y or n)"}

begin
	bool vb, db
	string idr, binning, apsize
	file idir, idpath, spec
	string fiber

	spec = spectrum
	idir = iddir
	fixdir (idir)
	idir = fixdir.newdir
	if (idir == "") {
	    idir = "tresdata$"
	    }
	idr = idroot
	if (idr == "") {
	    idr = "comp"
	    }
	vb = verbose
	db = debug

# Get fiber, binning, and aperture size for this spectrum
	trsfib.verbose = db
	trsfib.debug = db
	trsfib (spec)
	fiber = trsfib.fiber
	binning = trsfib.binning
	apsize = trsfib.apsize

# Get file name for fiber reference image
	imref = idr // apsize // binning // fiber // "p.ec.fits"
	idpath = idir // imref
	if (!access (idpath)) {
	    if (db)
		print ("TIDREF: ", idpath, " does not exist")
	    imref = idr // binning // fiber // "p.ec.fits"
	    idpath = idir // imref
	    if (!access (idpath)) {
		if (db)
		    print ("TIDREF: ", idpath, " does not exist")
		imref = idr // binning // "1p.ec.fits"
		idpath = idir // imref
		if (!access (idpath)) {
		    imref = ""
		    if (vb)
			print ("TIDREF: ", idpath, " does not exist")
		    return
		    }
		}
	    }
	if (vb)
	    print ("TIDREF: Calibration reference file is ",imref)

	return
end

# Jan 28 2008	New task
