# TXSTAT - Run imstat on several files, one image extension at a time
# January 15, 2008
# By Doug Mink, SAO Telescope Data Center

procedure txstat (images)

string	images=""	{prompt="Images to check"}

string	fields="image,npix,mean,stddev,min,max" {prompt="Fields to be printed"}
bool	deltemp=yes	{prompt="Delete intermediate image files (y or n)"}
bool	verbose=yes	{prompt="Print process progress (y or n)"}

begin

int	iext
file	templist, imin
string	ims, imsec, imlist, flds
bool	vb

	vb = verbose
	ims = images
	flds = fields

	if (ims == "") {
	    print ("TXSTAT:  Run imstat on a list of images one amp at a time")
	    print ("Usage: fxstat <input images with 2 extensions>")
	    return
	    }

#  Make temporary list of input files
	templist = mktemp ("txstatlist")
	files (ims, >templist)
	imlist = ""
	for (iext = 1; iext < 3; iext = iext + 1) {
	    list = templist
            while (fscan (list,imin) != EOF) {

# Run imstat on each extension of each image
		if (imlist != "")
		    imlist = imlist // ","
		imlist = imlist // imin // "[" // iext // "]"
		
		}
	    }
	imstat (imlist, fields=flds)

	delete (templist)
end

# Jan 15 2008	New program to process list of multiextension TRES images
